diff -ruN ../nakedmudv3.1/src/hooks.h src/hooks.h
--- ../nakedmudv3.1/src/hooks.h	Sun Dec  4 20:03:07 2005
+++ src/hooks.h	Sat Jul  1 20:06:58 2006
@@ -21,46 +21,19 @@
 //*****************************************************************************
 
 //
-// prepare hooks for use
-void init_hooks(void);
-
-//
-// creates a "middle-man" between hooks and the variables passed in when 
-// hookRun is called. The supplied function should take a LIST of hooks to
-// be run, and a VA_LIST of arguments. It should parse the arguments out of
-// VA_LIST and call each hook in the LIST with the arguments found in VA_LIST.
-void hook_add_handler(const char *type, 
-		      void(* handler)(LIST *hooks, va_list args));
-
-//
-// some handlers for use by outside modules not wanting to write their own hook
-// handlers. Each assumes a specific number of (void *) pointer arguments, and
-// no return value. If you want to support arguments of other sizes (like ints,
-// bools, etc) or would like your hooks to be able to return values, you will
-// have to write your own handler.
-void hook_handler_0_args(LIST *hooks, va_list args);
-void  hook_handler_1_arg(LIST *hooks, va_list args);
-void hook_handler_2_args(LIST *hooks, va_list args);
-void hook_handler_3_args(LIST *hooks, va_list args);
-void hook_handler_4_args(LIST *hooks, va_list args);
-void hook_handler_5_args(LIST *hooks, va_list args);
-void hook_handler_6_args(LIST *hooks, va_list args);
+// random character we use for denoting the beginning/end of a string
+#define HOOK_STR_MARKER '\033'
 
 //
-// This function attaches a hook to the game. It will run whenever a signal is
-// sent that a hook of "type" should run. A hook is a function. The number and
-// types of arguments that the function should take, as well as the type of 
-// return value the hook should supply depends on the type of hook it's added as
-void hookAdd(const char *type, void *hook);
-
-//
-// executes all of the hooks of the given type, with the given arguments. This
-// is sort of a sloppy way to provide hooks with arguments, but it's the best
-// I've come up with so far.
-void hookRun(const char *type, ...);
+// prepare hooks for use
+void init_hooks(void);
 
-//
-// remove the given hook
-void hookRemove(const char *type, void *hook);
+void hookRun(const char *type, const char *info);
+void hookAdd(const char *type, void (* func)(const char *));
+void hookAddMonitor(void (* func)(const char *, const char *));
+void hookRemove(const char *type, void (* func)(const char *));
+void hookParseInfo(const char *info, ...);
+const char *hookBuildInfo(const char *format, ...);
+LIST *parse_hook_info_tokens(const char *info);
 
 #endif // HOOKS_H
diff -ruN ../nakedmudv3.1/src/inform.c src/inform.c
--- ../nakedmudv3.1/src/inform.c	Sun Dec  4 20:03:07 2005
+++ src/inform.c	Sat Jul  1 20:06:58 2006
@@ -130,58 +130,56 @@
 //*****************************************************************************
 void look_at_obj(CHAR_DATA *ch, OBJ_DATA *obj) {
   // make our working copy of the description
-  BUFFER *new_desc = bufferCopy(objGetDescBuffer(obj));
+  bufferClear(charGetLookBuffer(ch));
+  bufferCat(charGetLookBuffer(ch), objGetDesc(obj));
 
   // do all of the preprocessing on the new descriptions
-  hookRun("preprocess_obj_desc", new_desc, obj, ch);
+  hookRun("preprocess_obj_desc", hookBuildInfo("obj ch", obj, ch));
 
   // append anything that might also go onto it
-  hookRun("append_obj_desc", new_desc, obj, ch);
+  hookRun("append_obj_desc", hookBuildInfo("obj ch", obj, ch));
 
   // colorize all of the edescs
-  edescTagDesc(new_desc, objGetEdescs(obj), "{c", "{g");
+  edescTagDesc(charGetLookBuffer(ch), objGetEdescs(obj), "{c", "{g");
 
   // format the desc, and send it
-  bufferFormat(new_desc, SCREEN_WIDTH, PARA_INDENT);
+  bufferFormat(charGetLookBuffer(ch), SCREEN_WIDTH, PARA_INDENT);
 
-  if(bufferLength(new_desc) == 0)
+  if(bufferLength(charGetLookBuffer(ch)) == 0)
     send_to_char(ch, "{g%s\r\n", NOTHING_SPECIAL);
   else
-    send_to_char(ch, "{g%s", bufferString(new_desc));
+    send_to_char(ch, "{g%s", bufferString(charGetLookBuffer(ch)));
 
-  // free up our mess
-  deleteBuffer(new_desc);
-
-  hookRun("look_at_obj", obj, ch);
+  hookRun("look_at_obj", hookBuildInfo("obj ch", obj, ch));
   send_to_char(ch, "{n");
 }
 
 
 void look_at_exit(CHAR_DATA *ch, EXIT_DATA *exit) {
   // make the working copy of the description, and fill it up with info
-  BUFFER *desc = bufferCopy(exitGetDescBuffer(exit));
+  bufferClear(charGetLookBuffer(ch));
+  bufferCat(charGetLookBuffer(ch), exitGetDesc(exit));
 
   // do all of our preprocessing of the description before we show it
-  hookRun("preprocess_exit_desc", desc, exit, ch);
+  hookRun("preprocess_exit_desc", hookBuildInfo("ex ch", exit, ch));
 
   // append anything that might also go onto it
-  hookRun("append_exit_desc", desc, exit, ch);
+  hookRun("append_exit_desc", hookBuildInfo("ex ch", exit, ch));
 
   // colorize all of the edescs
-  edescTagDesc(desc, roomGetEdescs(exitGetRoom(exit)), "{c", "{g");
+  edescTagDesc(charGetLookBuffer(ch), roomGetEdescs(exitGetRoom(exit)), 
+	       "{c", "{g");
 
   // format our description
-  bufferFormat(desc, SCREEN_WIDTH, PARA_INDENT);
+  bufferFormat(charGetLookBuffer(ch), SCREEN_WIDTH, PARA_INDENT);
 
   // if the buffer has nothing in it, send a "nothing special" message
-  if(bufferLength(desc) == 0)
+  if(bufferLength(charGetLookBuffer(ch)) == 0)
     send_to_char(ch, "{g%s\r\n", NOTHING_SPECIAL);
   else
-    send_to_char(ch, "{g%s", bufferString(desc));
-
-  deleteBuffer(desc);
+    send_to_char(ch, "{g%s", bufferString(charGetLookBuffer(ch)));
 
-  hookRun("look_at_exit", exit, ch);
+  hookRun("look_at_exit", hookBuildInfo("ex ch", exit, ch));
   send_to_char(ch, "{n");
 }
 
@@ -239,44 +237,25 @@
 }
 
 
-void show_body(CHAR_DATA *ch, BODY_DATA *body) {
-  int i, num_bodyparts;
-  const char **bodyparts = bodyGetParts(body, TRUE, &num_bodyparts);
-  OBJ_DATA    *equipment = NULL;
-  char posbuf[SMALL_BUFFER];
-  for(i = 0; i < num_bodyparts; i++) {
-    equipment = bodyGetEquipment(body, bodyparts[i]);
-    if(!equipment || !can_see_obj(ch, equipment))
-      continue;
-    sprintf(posbuf, "{c<{C%s{c>{n", bodyparts[i]);
-    send_to_char(ch, "%-30s %s\r\n", 
-		 posbuf, objGetName(equipment));
-  }
-  if(bodyparts) 
-    free(bodyparts);
-}
-
-
 void look_at_char(CHAR_DATA *ch, CHAR_DATA *vict) {
-  BUFFER *new_desc = bufferCopy(charGetDescBuffer(vict));
+  bufferClear(charGetLookBuffer(ch));
+  bufferCat(charGetLookBuffer(ch), charGetDesc(vict));
 
   // preprocess our desc before it it sent to the person
-  hookRun("preprocess_char_desc", new_desc, vict, ch);
+  hookRun("preprocess_char_desc", hookBuildInfo("ch ch", vict, ch));
 
   // append anything that might also go onto it
-  hookRun("append_char_desc", new_desc, vict, ch);
-    
+  hookRun("append_char_desc", hookBuildInfo("ch ch", vict, ch));
+
   // format and send it
-  bufferFormat(new_desc, SCREEN_WIDTH, PARA_INDENT);
+  bufferFormat(charGetLookBuffer(ch), SCREEN_WIDTH, PARA_INDENT);
 
-  if(bufferLength(new_desc) == 0)
+  if(bufferLength(charGetLookBuffer(ch)) == 0)
     send_to_char(ch, "{g%s\r\n", NOTHING_SPECIAL);
   else
-    send_to_char(ch, "{g%s{n", bufferString(new_desc));
+    send_to_char(ch, "{g%s{n", bufferString(charGetLookBuffer(ch)));
   
-  // clean up our mess
-  deleteBuffer(new_desc);
-  hookRun("look_at_char", vict, ch);
+  hookRun("look_at_char", hookBuildInfo("ch ch", vict, ch));
 }
 
 
@@ -288,27 +267,26 @@
   send_to_char(ch, "{c%s\r\n", roomGetName(room));
 
   // make the working copy of the description, and fill it up with info
-  BUFFER *desc = bufferCopy(roomGetDescBuffer(room));
-
+  bufferClear(charGetLookBuffer(ch));
+  bufferCat(charGetLookBuffer(ch), roomGetDesc(room));
   // do all of our preprocessing of the description before we show it
-  hookRun("preprocess_room_desc", desc, room, ch);
+  hookRun("preprocess_room_desc", hookBuildInfo("rm ch", room, ch));
 
   // append anything that might also go onto it
-  hookRun("append_room_desc", desc, room, ch);
+  hookRun("append_room_desc", hookBuildInfo("rm ch", room, ch));
 
   // colorize all of the edescs
-  edescTagDesc(desc, roomGetEdescs(room), "{c", "{g");
+  edescTagDesc(charGetLookBuffer(ch), roomGetEdescs(room), "{c", "{g");
 
   // format our description
-  bufferFormat(desc, SCREEN_WIDTH, PARA_INDENT);
+  bufferFormat(charGetLookBuffer(ch), SCREEN_WIDTH, PARA_INDENT);
 
-  if(bufferLength(desc) == 0)
+  if(bufferLength(charGetLookBuffer(ch)) == 0)
     send_to_char(ch, "{g%s\r\n", NOTHING_SPECIAL);
   else
-    send_to_char(ch, "{g%s", bufferString(desc));
+    send_to_char(ch, "{g%s", bufferString(charGetLookBuffer(ch)));
 
-  deleteBuffer(desc);
-  hookRun("look_at_room", room, ch);
+  hookRun("look_at_room", hookBuildInfo("rm ch", room, ch));
   send_to_char(ch, "{n");
 }
 
@@ -522,77 +500,14 @@
 
 
 //
-// list all of the equipment a character is wearing to him or herself
-COMMAND(cmd_equipment) {
-  send_to_char(ch, "You are wearing:\r\n");
-  show_body(ch, charGetBody(ch));
-}
-
-
-//
-// list a character's inventory to him or herself
-COMMAND(cmd_inventory) {
-  if(listSize(charGetInventory(ch)) == 0)
-    send_to_char(ch, "You aren't carrying anything.\r\n");
-  else {
-    send_to_char(ch, "{gYou are carrying:\r\n");
-    LIST *vis_objs = find_all_objs(ch, charGetInventory(ch), "", NULL, TRUE);
-    show_list(ch, vis_objs, objGetName, objGetMultiName);
-    deleteList(vis_objs);
-  }
-}
-
-
-//
 // show a list of all commands available to the character
 COMMAND(cmd_commands) {
-  show_commands(ch, bitvectorGetBits(charGetUserGroups(ch)));
-}
-
-
-//
-// builds a buffer that lists all of the people online. 
-// Buffer must be deleted after it is used
-BUFFER *build_who(void) {
-  CHAR_DATA *plr;
-  SOCKET_DATA *dsock;
-  BUFFER *buf = newBuffer(MAX_BUFFER);
-  LIST_ITERATOR *sock_i = newListIterator(socket_list);
-  int socket_count = 0, playing_count = 0;
-
-  bprintf(buf, 
-	  "{cPlayers Online:\r\n"
-	  "{gStatus   Race )\r\n"
-	  );
-
-  // build our list of people online
-  ITERATE_LIST(dsock, sock_i) {
-    socket_count++;
-    if ((plr = socketGetChar(dsock)) == NULL) continue;
-    playing_count++;
-    bprintf(buf, "{y%-8s %-3s  {g)  {c%-12s {b%26s\r\n",
-	    (bitIsSet(charGetUserGroups(plr), "admin") ? "admin" :
-	     (bitIsSet(charGetUserGroups(plr), "scripter") ? "scripter" :
-	      (bitIsSet(charGetUserGroups(plr), "builder") ? "builder"  :
-	       (bitIsSet(charGetUserGroups(plr), "player") ? "player" : 
-		"noone!")))),
-	    raceGetAbbrev(charGetRace(plr)),
-	    charGetName(plr), socketGetHostname(dsock));
-  } deleteListIterator(sock_i);
-
-  // send out info about the number of sockets and players logged on
-  bprintf(buf, "\r\n{g%d socket%s connected. %d playing.\r\n",
-	  socket_count, (socket_count == 1 ? "" : "s"), playing_count);
-  return buf;
-}
-
-
-//
-// show the player all of the people who are currently playing
-COMMAND(cmd_who) {
-  BUFFER *buf = build_who();
-  page_string(charGetSocket(ch), bufferString(buf));
-  deleteBuffer(buf);
+  if(!*arg)
+    show_commands(ch, bitvectorGetBits(charGetUserGroups(ch)));
+  else if(!bitIsAllSet(charGetUserGroups(ch), arg))
+    send_to_char(ch, "You are not a member of all user groups: %s.\r\n", arg);
+  else
+    show_commands(ch, arg);
 }
 
 
@@ -849,8 +764,13 @@
   deleteListWith(exnames, free);
 }
 
-void exit_append_hook(BUFFER *buf, EXIT_DATA *exit, CHAR_DATA *ch) {
+void exit_append_hook(const char *info) {
   // before anything, figure out some basic information like our dir and dest
+  EXIT_DATA     *exit = NULL;
+  CHAR_DATA       *ch = NULL;
+  hookParseInfo(info, &exit, &ch);
+
+  BUFFER         *buf = charGetLookBuffer(ch);
   ROOM_DATA     *room = exitGetRoom(exit);
   ROOM_DATA     *dest = worldGetRoom(gameworld, exitGetTo(exit));
   LIST       *exnames = roomGetExitNames(room);
@@ -888,7 +808,10 @@
   if(dir) free(dir);
 }
 
-void exit_look_hook(EXIT_DATA *exit, CHAR_DATA *ch) {
+void exit_look_hook(const char *info) {
+  EXIT_DATA *exit = NULL;
+  CHAR_DATA   *ch = NULL;
+  hookParseInfo(info, &exit, &ch);
   // the door is not closed, list off the people we can see as well
   if(!exitIsClosed(exit)) {
     ROOM_DATA *room = worldGetRoom(gameworld, exitGetTo(exit));
@@ -897,14 +820,10 @@
   }
 }
 
-void body_look_hook(CHAR_DATA *vict, CHAR_DATA *ch) {
-  send_to_char(ch, "\r\n{g%s %s wearing:\r\n", 
-	       (ch == vict ? "You" : HESHE(vict)),
-	       (ch == vict ? "are" : "is"));
-  show_body(ch, charGetBody(vict));
-}
-
-void room_look_hook(ROOM_DATA *room, CHAR_DATA *ch) {
+void room_look_hook(const char *info) {
+  ROOM_DATA *room = NULL;
+  CHAR_DATA   *ch = NULL;
+  hookParseInfo(info, &room, &ch);
   list_room_exits(ch, room);
   list_room_contents(ch, room);
 }
@@ -915,25 +834,10 @@
 // initialization of inform.h
 //*****************************************************************************
 void init_inform(void) {
-  // add all of our hook types
-  hook_add_handler("preprocess_room_desc", hook_handler_3_args);
-  hook_add_handler("preprocess_obj_desc",  hook_handler_3_args);
-  hook_add_handler("preprocess_char_desc", hook_handler_3_args);
-  hook_add_handler("preprocess_exit_desc", hook_handler_3_args);
-  hook_add_handler("append_room_desc",     hook_handler_3_args);
-  hook_add_handler("append_obj_desc",      hook_handler_3_args);
-  hook_add_handler("append_char_desc",     hook_handler_3_args);
-  hook_add_handler("append_exit_desc",     hook_handler_3_args);
-  hook_add_handler("look_at_room",         hook_handler_2_args);
-  hook_add_handler("look_at_obj",          hook_handler_2_args);
-  hook_add_handler("look_at_char",         hook_handler_2_args);
-  hook_add_handler("look_at_exit",         hook_handler_2_args);
-
   // attach hooks
   hookAdd("append_exit_desc", exit_append_hook);
   // enable if you want exits to append to the end of room descs
   //  hookAdd("append_room_desc", exit_append_room_hook);
-  hookAdd("look_at_exit",     exit_look_hook);
-  hookAdd("look_at_char",     body_look_hook);
-  hookAdd("look_at_room",     room_look_hook);
+  hookAdd("look_at_exit", exit_look_hook);
+  hookAdd("look_at_room", room_look_hook);
 }
diff -ruN ../nakedmudv3.1/src/inform.h src/inform.h
--- ../nakedmudv3.1/src/inform.h	Sun Dec  4 20:03:07 2005
+++ src/inform.h	Sat Jul  1 20:06:58 2006
@@ -150,11 +150,4 @@
 //
 void show_body(CHAR_DATA *ch, BODY_DATA *body);
 
-
-//
-// builds a buffer that lists all of the people online. 
-// Buffer must be deleted after it is used
-BUFFER *build_who(void);
-
-
 #endif // __INFORM_H
diff -ruN ../nakedmudv3.1/src/interpret.c src/interpret.c
--- ../nakedmudv3.1/src/interpret.c	Sun Dec  4 20:03:07 2005
+++ src/interpret.c	Sat Jul  1 20:06:58 2006
@@ -10,7 +10,6 @@
 #include "character.h"
 #include "socket.h"
 #include "room.h"
-#include "movement.h"    // for try_move_special
 #include "commands.h"
 #include "action.h"
 
@@ -49,210 +48,18 @@
   // functions to the MUD, they should be added in the init_xxx() function
   // associated with your module.
   //***************************************************************************
-  add_cmd("north", "n", cmd_move, POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("east",  "e", cmd_move, POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("south", "s", cmd_move, POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("west",  "w", cmd_move, POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("up",    "u", cmd_move, POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("down",  "d", cmd_move, POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("northeast", "na", cmd_move, POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("southeast", "sa",  cmd_move, POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("southwest", "sb", cmd_move, POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("northwest", "nb", cmd_move, POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("ne",        "ne", cmd_move, POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("se",        "se", cmd_move, POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("sw",        "sw", cmd_move, POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("nw",        "nw", cmd_move, POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-
-  // A
-  add_cmd("approach",   NULL, cmd_greet,    POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("ask",        NULL, cmd_ask,      POS_SITTING,  POS_FLYING,
-	  "player", TRUE, FALSE);
-  add_cmd("at",         NULL, cmd_at,       POS_UNCONCIOUS, POS_FLYING,
-	  "builder", TRUE, FALSE);
-
-  // B
   add_cmd("back",       NULL, cmd_back,     POS_UNCONCIOUS, POS_FLYING,
 	  "player", TRUE, FALSE);
-
-  // C
-  add_cmd("chat",       NULL, cmd_chat,     POS_UNCONCIOUS, POS_FLYING,
-	  "player", TRUE, FALSE);
-  add_cmd("clear",      NULL, cmd_clear,    POS_UNCONCIOUS, POS_FLYING,
-	  "player", TRUE, FALSE);
-  add_cmd("close",      NULL, cmd_close,    POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
   add_cmd("commands",   NULL, cmd_commands, POS_UNCONCIOUS, POS_FLYING,
 	  "player", TRUE, FALSE);
   add_cmd("compress",   NULL, cmd_compress, POS_UNCONCIOUS, POS_FLYING,
 	  "player", FALSE, FALSE);
-  add_cmd("copyover",   NULL, cmd_copyover, POS_UNCONCIOUS, POS_FLYING,
-	  "admin",  FALSE, TRUE);
-
-  // D
-  add_cmd("delay",      NULL, cmd_delay,    POS_SLEEPING, POS_FLYING,
-	  "player", TRUE,  FALSE);
-  add_cmd("drop",       NULL, cmd_drop,     POS_SITTING,  POS_FLYING,
-	  "player", TRUE, TRUE );
-
-  // E
-  add_cmd("emote",      NULL, cmd_emote,    POS_SITTING,  POS_FLYING,
-	  "player", TRUE, FALSE);
-  add_cmd(":",          NULL, cmd_emote,    POS_SITTING,  POS_FLYING,
-	  "player", TRUE, FALSE);
-  add_cmd("equipment",  NULL, cmd_equipment,POS_SITTING,  POS_FLYING,
-	  "player", TRUE, FALSE);
-
-  // F
-  add_cmd("force",      NULL, cmd_force,    POS_STANDING, POS_FLYING,
-	  "admin",   FALSE, FALSE);
-
-  // G
-  add_cmd("gemote",     NULL, cmd_gemote,   POS_UNCONCIOUS, POS_FLYING,
-	  "player", TRUE, FALSE);
-  add_cmd("give",       NULL, cmd_give,     POS_SITTING,  POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("gossip",     NULL, cmd_chat,     POS_UNCONCIOUS, POS_FLYING,
-	  "player", TRUE, FALSE);
-  add_cmd("\"",         NULL, cmd_chat,     POS_UNCONCIOUS, POS_FLYING,
-	  "player", TRUE, FALSE);
-  add_cmd("greet",      NULL, cmd_greet,    POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("get",        NULL, cmd_get,      POS_SITTING,  POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("goto",       NULL, cmd_goto,     POS_STANDING, POS_FLYING,
-	  "builder", FALSE, TRUE );
   add_cmd("groupcmds",  NULL, cmd_groupcmds,POS_UNCONCIOUS, POS_FLYING,
 	  "player", FALSE, FALSE);
-
-  // I
-  add_cmd("inventory",  NULL, cmd_inventory,POS_SITTING,  POS_FLYING,
-	  "player", TRUE, FALSE);
-
-  // L
   add_cmd("look",       "l",  cmd_look,     POS_SITTING,  POS_FLYING,
 	  "player", TRUE, FALSE);
-  add_cmd("lock",       NULL,  cmd_lock,    POS_STANDING,  POS_FLYING,
-	  "player", TRUE, TRUE);
-  add_cmd("land",       NULL, cmd_stand,    POS_FLYING,   POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("load",       NULL, cmd_load,     POS_SITTING,  POS_FLYING,
-	  "builder", FALSE, FALSE);
-  add_cmd("linkdead",   NULL, cmd_linkdead, POS_UNCONCIOUS, POS_FLYING,
-	  "admin", FALSE, FALSE);
-  add_cmd("lockdown",   NULL, cmd_lockdown, POS_UNCONCIOUS, POS_FLYING,
-	  "admin", FALSE, FALSE);
-
-  // M
-  add_cmd("mlist",      NULL, cmd_mlist,    POS_UNCONCIOUS, POS_FLYING,
-	  "builder", FALSE, FALSE);
-  add_cmd("mdelete",    NULL, cmd_mdelete,  POS_UNCONCIOUS, POS_FLYING,
-	  "builder", FALSE, FALSE);
-  add_cmd("mrename",    NULL, cmd_mrename,  POS_UNCONCIOUS, POS_FLYING,
-	  "builder", FALSE, FALSE);
   add_cmd("more",       NULL, cmd_more,     POS_UNCONCIOUS, POS_FLYING,
 	  "player", TRUE, FALSE);
-  add_cmd("motd",       NULL, cmd_motd,     POS_UNCONCIOUS, POS_FLYING,
-	  "player", TRUE, FALSE);
-
-  // O
-  add_cmd("olist",      NULL, cmd_olist,    POS_UNCONCIOUS, POS_FLYING,
-	  "builder", FALSE, FALSE);
-  add_cmd("odelete",    NULL, cmd_odelete,  POS_UNCONCIOUS, POS_FLYING,
-	  "builder", FALSE, FALSE);
-  add_cmd("orename",    NULL, cmd_orename,  POS_UNCONCIOUS, POS_FLYING,
-	  "builder", FALSE, FALSE);
-  add_cmd("open",       NULL, cmd_open,     POS_STANDING, POS_FLYING,
-	  "player", TRUE, TRUE );
-
-  // P
-  add_cmd("put",        "p", cmd_put,       POS_SITTING,  POS_FLYING,
-	  "player", TRUE,  TRUE );
-  add_cmd("page",       NULL, cmd_page,     POS_SITTING,  POS_FLYING,
-	  "builder", TRUE, FALSE);
-  add_cmd("purge",      NULL, cmd_purge,    POS_SITTING,  POS_FLYING,
-	  "builder", FALSE, FALSE);
-  add_cmd("pulserate",  NULL, cmd_pulserate,POS_UNCONCIOUS, POS_FLYING,
-	  "admin", FALSE, FALSE);
-  
-  // Q
-  add_cmd("quit",       NULL, cmd_quit,     POS_SLEEPING, POS_FLYING,
-	  "player", FALSE, TRUE );
-
-  // R
-  add_cmd("rreload",    NULL, cmd_rreload,  POS_UNCONCIOUS, POS_FLYING,
-	  "builder", FALSE, FALSE);
-  add_cmd("remove",     NULL, cmd_remove,   POS_SITTING, POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("repeat",     NULL, cmd_repeat,   POS_UNCONCIOUS, POS_FLYING,
-	  "admin", FALSE, FALSE);
-  add_cmd("rlist",      NULL, cmd_rlist,    POS_UNCONCIOUS, POS_FLYING,
-	  "builder", FALSE, FALSE);
-  add_cmd("rdelete",    NULL, cmd_rdelete,  POS_UNCONCIOUS, POS_FLYING,
-	  "builder", FALSE, FALSE);
-  add_cmd("rrename",    NULL, cmd_rrename,  POS_UNCONCIOUS, POS_FLYING,
-	  "builder", FALSE, FALSE);
-
-  // S
-  add_cmd("say",        NULL, cmd_say,      POS_SITTING,  POS_FLYING,
-	  "player", TRUE, FALSE);
-  add_cmd("'",          NULL, cmd_say,      POS_SITTING,  POS_FLYING,
-	  "player", TRUE, FALSE);
-  add_cmd("save",       NULL, cmd_save,     POS_SLEEPING, POS_FLYING,
-	  "player", FALSE, FALSE);
-  add_cmd("shutdown",   NULL, cmd_shutdown, POS_UNCONCIOUS, POS_FLYING,
-	  "admin", FALSE, TRUE );
-  add_cmd("sit",        NULL, cmd_sit,      POS_SITTING,  POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("sleep",      NULL, cmd_sleep,    POS_SITTING,  POS_STANDING,
-	  "player", TRUE, FALSE);
-  add_cmd("stand",      NULL, cmd_stand,    POS_SITTING,  POS_STANDING,
-	  "player", TRUE, TRUE );
-  add_cmd("stop",       NULL, cmd_stop,     POS_SITTING, POS_FLYING,
-	  "player", TRUE, FALSE);
-
-  // T
-  add_cmd("take",       NULL, cmd_get,      POS_SITTING,  POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("tell",       NULL, cmd_tell,     POS_SLEEPING, POS_FLYING,
-	  "player", TRUE, FALSE);
-  add_cmd("transfer",   NULL, cmd_transfer, POS_STANDING, POS_FLYING,
-	  "builder", FALSE, TRUE);
-
-  // U
-  add_cmd("unlock",       NULL,  cmd_unlock,    POS_STANDING,  POS_FLYING,
-	  "player", TRUE, TRUE);
-
-  // W
-  add_cmd("wake",       NULL, cmd_wake,     POS_SLEEPING,  POS_SLEEPING,
-	  "player", TRUE, TRUE );
-  add_cmd("wear",       NULL, cmd_wear,     POS_SITTING,  POS_FLYING,
-	  "player", TRUE, TRUE );
-  add_cmd("who",        NULL, cmd_who,      POS_UNCONCIOUS, POS_FLYING,
-	  "player", TRUE, FALSE);
-  add_cmd("worn",       NULL, cmd_equipment,POS_SITTING,  POS_FLYING,
-	  "player", TRUE, FALSE);
-
-  // Z
-  add_cmd("zlist",      NULL, cmd_zlist,    POS_SITTING,  POS_FLYING,
-	  "builder", FALSE, TRUE);
-  add_cmd("zreset",     NULL, cmd_zreset,   POS_UNCONCIOUS, POS_FLYING,
-	  "builder", FALSE, FALSE);
 }
 
 
diff -ruN ../nakedmudv3.1/src/items/container.c src/items/container.c
--- ../nakedmudv3.1/src/items/container.c	Sun Dec  4 20:03:07 2005
+++ src/items/container.c	Sat Jul  1 20:06:58 2006
@@ -10,6 +10,7 @@
 #include "../mud.h"
 #include "../storage.h"
 #include "../object.h"
+#include "../character.h"
 #include "../world.h"
 #include "../socket.h"
 #include "../utils.h"
@@ -499,14 +500,23 @@
 //*****************************************************************************
 // hooks
 //*****************************************************************************
-void container_append_hook(BUFFER *desc, OBJ_DATA *obj, CHAR_DATA *ch) {
+void container_append_hook(const char *info) {
+  OBJ_DATA *obj = NULL;
+  CHAR_DATA *ch = NULL;
+  hookParseInfo(info, &obj, &ch);
+
   if(objIsType(obj, "container")) {
-    bprintf(desc, " It is %s%s.", (containerIsClosed(obj) ? "closed":"open"),
+    bprintf(charGetLookBuffer(ch), " It is %s%s.", 
+	    (containerIsClosed(obj) ? "closed":"open"),
 	    (containerIsLocked(obj) ? " and locked" : ""));
   }
 }
 
-void container_look_hook(OBJ_DATA *obj, CHAR_DATA *ch) {
+void container_look_hook(const char *info) {
+  OBJ_DATA *obj = NULL;
+  CHAR_DATA *ch = NULL;
+  hookParseInfo(info, &obj, &ch);
+
   if(objIsType(obj, "container") && !containerIsClosed(obj)) {
     LIST *vis_contents = find_all_objs(ch, objGetContents(obj), "", 
 				       NULL, TRUE);
diff -ruN ../nakedmudv3.1/src/items/furniture.c src/items/furniture.c
--- ../nakedmudv3.1/src/items/furniture.c	Sun Dec  4 20:03:07 2005
+++ src/items/furniture.c	Sat Jul  1 20:06:58 2006
@@ -275,15 +275,20 @@
 //*****************************************************************************
 // hooks
 //*****************************************************************************
-void furniture_append_hook(BUFFER *buf, OBJ_DATA *obj, CHAR_DATA *ch) {
+void furniture_append_hook(const char *info) {
+  OBJ_DATA *obj = NULL;
+  CHAR_DATA *ch = NULL;
+  hookParseInfo(info, &obj, &ch);
+
   if(objIsType(obj, "furniture")) {
     int num_sitters = listSize(objGetUsers(obj));
 
     // print out how much room there is left on the furniture
     int seats_left = (furnitureGetCapacity(obj) - num_sitters);
     if(seats_left > 0)
-      bprintf(buf, " It looks like it could fit %d more %s.\r\n",
-		   seats_left, (seats_left == 1 ? "person" : "people"));
+      bprintf(charGetLookBuffer(ch), 
+	      " It looks like it could fit %d more %s.\r\n",
+	      seats_left, (seats_left == 1 ? "person" : "people"));
 
     // print character names
     if(num_sitters > 0) {
@@ -291,7 +296,7 @@
       listRemove(can_see, ch);
 
       char *chars = print_list(can_see, charGetName, charGetMultiName);
-      if(*chars) bprintf(buf, "%s %s %s %s%s.\r\n",
+      if(*chars) bprintf(charGetLookBuffer(ch), "%s %s %s %s%s.\r\n",
 			 chars, (listSize(can_see) == 1 ? "is" : "are"),
 			 (furnitureGetType(obj) == FURNITURE_AT ? "at":"on"),
 			 see_obj_as(ch, obj),
diff -ruN ../nakedmudv3.1/src/items/portal.c src/items/portal.c
--- ../nakedmudv3.1/src/items/portal.c	Sun Dec  4 20:03:07 2005
+++ src/items/portal.c	Sat Jul  1 20:06:58 2006
@@ -15,7 +15,6 @@
 #include "../socket.h"
 #include "../room.h"
 #include "../world.h"
-#include "../movement.h"
 #include "../inform.h"
 #include "../handler.h"
 #include "../hooks.h"
@@ -138,41 +137,34 @@
 //   examples:
 //     enter portal         enter the thing called "portal" in your room
 COMMAND(cmd_enter) {
-  void    *found = NULL;
-  int found_type = PARSE_NONE;
+  void *obj = NULL;
 
-  if(!parse_args(ch, TRUE, cmd, arg, "{ obj.room exit }", &found, &found_type))
+  if(!parse_args(ch, TRUE, cmd, arg, "obj.room", &obj))
     return;
 
-  // we're trying to enter an exit
-  if(found_type == PARSE_EXIT)
-    try_move_mssg(ch, roomGetExitDir(charGetRoom(ch), found));
-
   // we're trying to enter a portal
+  if(!objIsType(obj, "portal"))
+    send_to_char(ch, "You cannot seem to find an enterance.\r\n");
   else {
-    if(!objIsType(found, "portal"))
-      send_to_char(ch, "You cannot seem to find an enterance.\r\n");
+    ROOM_DATA *dest = worldGetRoom(gameworld, portalGetDest(obj));
+    if(dest == NULL)
+      send_to_char(ch, "There is nothing on the other side...\r\n");
     else {
-      ROOM_DATA *dest = worldGetRoom(gameworld, portalGetDest(found));
-      if(dest == NULL)
-	send_to_char(ch, "There is nothing on the other side...\r\n");
-      else {
-	if(*portalGetLeaveMssg(found))
-	  message(ch, NULL, found,NULL,TRUE,TO_ROOM, portalGetLeaveMssg(found));
-	else
-	  message(ch, NULL, found, NULL, TRUE, TO_ROOM, "$n steps into $o.");
-
-	// transfer our character and look
-	char_from_room(ch);
-	char_to_room(ch, dest);
-	look_at_room(ch, dest);
-
-	if(*portalGetEnterMssg(found))
-	  message(ch, NULL, found,NULL,TRUE,TO_ROOM, portalGetEnterMssg(found));
-	else
-	  message(ch, NULL, found, NULL, TRUE, TO_ROOM,
-		  "$n arrives after travelling through $o.");
-      }
+      if(*portalGetLeaveMssg(obj))
+	message(ch, NULL, obj,NULL,TRUE,TO_ROOM, portalGetLeaveMssg(obj));
+      else
+	message(ch, NULL, obj, NULL, TRUE, TO_ROOM, "$n steps into $o.");
+      
+      // transfer our character and look
+      char_from_room(ch);
+      char_to_room(ch, dest);
+      look_at_room(ch, dest);
+      
+      if(*portalGetEnterMssg(obj))
+	message(ch, NULL, obj,NULL,TRUE,TO_ROOM, portalGetEnterMssg(obj));
+      else
+	message(ch, NULL, obj, NULL, TRUE, TO_ROOM,
+		"$n arrives after travelling through $o.");
     }
   }
 }
@@ -390,7 +382,11 @@
 //*****************************************************************************
 // add our hookds
 //*****************************************************************************
-void portal_look_hook(OBJ_DATA *obj, CHAR_DATA *ch) {
+void portal_look_hook(const char *info) {
+  OBJ_DATA *obj = NULL;
+  CHAR_DATA *ch = NULL;
+  hookParseInfo(info, &obj, &ch);
+
   if(objIsType(obj, "portal")) {
     ROOM_DATA *dest = worldGetRoom(gameworld, portalGetDest(obj));
     if(dest != NULL) {
diff -ruN ../nakedmudv3.1/src/items/worn.c src/items/worn.c
--- ../nakedmudv3.1/src/items/worn.c	Sun Dec  4 20:03:07 2005
+++ src/items/worn.c	Sat Jul  1 20:06:58 2006
@@ -76,9 +76,13 @@
 
 //
 // append information about where the item can be worn
-void append_worn_hook(BUFFER *desc, OBJ_DATA *obj, CHAR_DATA *ch) {
+void append_worn_hook(const char *info) {
+  OBJ_DATA *obj = NULL;
+  CHAR_DATA *ch = NULL;
+  hookParseInfo(info, &obj, &ch);
+
   if(objIsType(obj, "worn")) {
-    bprintf(desc, "When worn, this item covers bodyparts: %s.", 
+    bprintf(charGetLookBuffer(ch),"When worn, this item covers bodyparts: %s.",
 	    wornGetPositions(obj));
   }
 }
